"use strict";
var httpStatusCode_1 = require("../utils/httpStatusCode");
var API;
(function (API) {
    var LobbyAPI = (function () {
        function LobbyAPI(_server) {
            this.server = _server;
            this.socket = _server.getSocket();
        }
        LobbyAPI.prototype.checkIn = function (msg) {
            var self = this;
            return new Promise(function (resolve, rejected) {
                // <!-- Authentication.
                self.socket.request("connector.entryHandler.login", msg, function (res) {
                    if (res.code === httpStatusCode_1.HttpStatusCode.fail) {
                        rejected(res.message);
                    }
                    else if (res.code === httpStatusCode_1.HttpStatusCode.success) {
                        resolve(res);
                    }
                    else {
                        resolve(res);
                    }
                });
            });
        };
        LobbyAPI.prototype.logout = function () {
            var registrationId = "";
            var msg = {};
            msg["username"] = null;
            msg["registrationId"] = registrationId;
            if (this.socket != null) {
                this.socket.notify("connector.entryHandler.logout", msg);
            }
            this.server.disConnect();
            this.server = null;
        };
        // <!-- Join and leave chat room.
        LobbyAPI.prototype.joinRoom = function (token, username, room_id, callback) {
            var self = this;
            var msg = {};
            msg["token"] = token;
            msg["rid"] = room_id;
            msg["username"] = username;
            self.socket.request("connector.entryHandler.enterRoom", msg, function (result) {
                if (callback !== null) {
                    callback(null, result);
                }
            });
        };
        LobbyAPI.prototype.leaveRoom = function (token, roomId, callback) {
            var self = this;
            var msg = {};
            msg["token"] = token;
            msg["rid"] = roomId;
            self.socket.request("connector.entryHandler.leaveRoom", msg, function (result) {
                if (callback != null)
                    callback(null, result);
            });
        };
        return LobbyAPI;
    }());
    API.LobbyAPI = LobbyAPI;
})(API = exports.API || (exports.API = {}));
